// generated by diplomat-tool
import type { CodePointRangeIterator } from "./CodePointRangeIterator"
import type { CodePointSetData } from "./CodePointSetData"
import type { DataError } from "./DataError"
import type { DataProvider } from "./DataProvider"
import type { pointer, codepoint } from "./diplomat-runtime.d.ts";


/** An ICU4X Unicode Map Property object, capable of querying whether a code point (key) to obtain the Unicode property value, for a specific Unicode property.
*
*For properties whose values fit into 16 bits.
*
*See the [Rust documentation for `properties`](https://docs.rs/icu/latest/icu/properties/index.html) for more information.
*
*See the [Rust documentation for `CodePointMapData`](https://docs.rs/icu/latest/icu/properties/struct.CodePointMapData.html) for more information.
*
*See the [Rust documentation for `CodePointMapDataBorrowed`](https://docs.rs/icu/latest/icu/properties/struct.CodePointMapDataBorrowed.html) for more information.
*/


export class CodePointMapData16 {
    
    get ffiValue(): pointer;

    get(cp: codepoint): number;

    iterRangesForValue(value: number): CodePointRangeIterator;

    iterRangesForValueComplemented(value: number): CodePointRangeIterator;

    getSetForValue(value: number): CodePointSetData;

    static createScript(): CodePointMapData16;

    static createScriptWithProvider(provider: DataProvider): CodePointMapData16;
}