// generated by diplomat-tool
import type { Calendar } from "./Calendar"
import type { CalendarError } from "./CalendarError"
import type { CalendarParseError } from "./CalendarParseError"
import type { IsoDate } from "./IsoDate"
import type { WeekCalculator } from "./WeekCalculator"
import type { WeekOf } from "./WeekOf"
import type { Weekday } from "./Weekday"
import type { pointer, codepoint } from "./diplomat-runtime.d.ts";


/** An ICU4X Date object capable of containing a date and time for any calendar.
*
*See the [Rust documentation for `Date`](https://docs.rs/icu/latest/icu/calendar/struct.Date.html) for more information.
*/


export class Date {
    
    get ffiValue(): pointer;

    static fromIsoInCalendar(year: number, month: number, day: number, calendar: Calendar): Date;

    static fromCodesInCalendar(eraCode: string, year: number, monthCode: string, day: number, calendar: Calendar): Date;

    static fromString(v: string, calendar: Calendar): Date;

    toCalendar(calendar: Calendar): Date;

    toIso(): IsoDate;

    get dayOfYear(): number;

    get dayOfMonth(): number;

    get dayOfWeek(): Weekday;

    weekOfMonth(firstWeekday: Weekday): number;

    weekOfYear(calculator: WeekCalculator): WeekOf;

    get ordinalMonth(): number;

    get monthCode(): string;

    get monthNumber(): number;

    get monthIsLeap(): boolean;

    get yearInEra(): number;

    get extendedYear(): number;

    get era(): string;

    get monthsInYear(): number;

    get daysInMonth(): number;

    get daysInYear(): number;

    get calendar(): Calendar;
}