// generated by diplomat-tool
import type { DataError } from "./DataError"
import type { DataProvider } from "./DataProvider"
import type { Decimal } from "./Decimal"
import type { DecimalGroupingStrategy } from "./DecimalGroupingStrategy"
import type { Locale } from "./Locale"
import type { pointer, codepoint } from "./diplomat-runtime.d.ts";


/** An ICU4X Decimal Format object, capable of formatting a [`Decimal`] as a string.
*
*See the [Rust documentation for `DecimalFormatter`](https://docs.rs/icu/latest/icu/decimal/struct.DecimalFormatter.html) for more information.
*/


export class DecimalFormatter {
    
    get ffiValue(): pointer;

    static createWithGroupingStrategy(locale: Locale, groupingStrategy: DecimalGroupingStrategy | null): DecimalFormatter;

    static createWithGroupingStrategyAndProvider(provider: DataProvider, locale: Locale, groupingStrategy: DecimalGroupingStrategy | null): DecimalFormatter;

    static createWithManualData(plusSignPrefix: string, plusSignSuffix: string, minusSignPrefix: string, minusSignSuffix: string, decimalSeparator: string, groupingSeparator: string, primaryGroupSize: number, secondaryGroupSize: number, minGroupSize: number, digits: Array<codepoint>, groupingStrategy: DecimalGroupingStrategy | null): DecimalFormatter;

    format(value: Decimal): string;
}