// generated by diplomat-tool
import type { DataProvider } from "./DataProvider"
import type { DateTimeFormatterLoadError } from "./DateTimeFormatterLoadError"
import type { DateTimeLength } from "./DateTimeLength"
import type { IsoDate } from "./IsoDate"
import type { Locale } from "./Locale"
import type { pointer, codepoint } from "./diplomat-runtime.d.ts";


/** An ICU4X TypedDateFormatter object capable of formatting an [`IsoDate`] and a [`Time`] as a string,
*using the Gregorian Calendar.
*
*See the [Rust documentation for `FixedCalendarDateTimeFormatter`](https://docs.rs/icu/latest/icu/datetime/struct.FixedCalendarDateTimeFormatter.html) for more information.
*
*Additional information: [1](https://docs.rs/icu/latest/icu/datetime/fieldsets/struct.YMD.html)
*/


export class GregorianDateFormatter {
    
    get ffiValue(): pointer;

    static createWithLength(locale: Locale, length: DateTimeLength): GregorianDateFormatter;

    static createWithLengthAndProvider(provider: DataProvider, locale: Locale, length: DateTimeLength): GregorianDateFormatter;

    formatIso(value: IsoDate): string;
}