// generated by diplomat-tool
import type { CodePointRangeIterator } from "./CodePointRangeIterator"
import type { DataError } from "./DataError"
import type { DataProvider } from "./DataProvider"
import type { ScriptWithExtensionsBorrowed } from "./ScriptWithExtensionsBorrowed"
import type { pointer, codepoint } from "./diplomat-runtime.d.ts";


/** An ICU4X ScriptWithExtensions map object, capable of holding a map of codepoints to scriptextensions values
*
*See the [Rust documentation for `ScriptWithExtensions`](https://docs.rs/icu/latest/icu/properties/script/struct.ScriptWithExtensions.html) for more information.
*/


export class ScriptWithExtensions {
    
    get ffiValue(): pointer;

    static createWithProvider(provider: DataProvider): ScriptWithExtensions;

    getScriptVal(ch: codepoint): number;

    hasScript(ch: codepoint, script: number): boolean;

    get asBorrowed(): ScriptWithExtensionsBorrowed;

    iterRangesForScript(script: number): CodePointRangeIterator;

    constructor();
}