// generated by diplomat-tool
import type { DataError } from "./DataError"
import type { DataProvider } from "./DataProvider"
import type { MeasureUnit } from "./MeasureUnit"
import type { MeasureUnitParser } from "./MeasureUnitParser"
import type { UnitsConverter } from "./UnitsConverter"
import type { pointer, codepoint } from "./diplomat-runtime.d.ts";


/** An ICU4X Units Converter Factory object, capable of creating converters a [`UnitsConverter`]
*for converting between two [`MeasureUnit`]s.
*
*Also, it can parse the CLDR unit identifier (e.g. `meter-per-square-second`) and get the [`MeasureUnit`].
*
*See the [Rust documentation for `ConverterFactory`](https://docs.rs/icu/latest/icu/experimental/units/converter_factory/struct.ConverterFactory.html) for more information.
*/


export class UnitsConverterFactory {
    
    get ffiValue(): pointer;

    static createWithProvider(provider: DataProvider): UnitsConverterFactory;

    converter(from: MeasureUnit, to: MeasureUnit): UnitsConverter | null;

    parser(): MeasureUnitParser;

    constructor();
}