// generated by diplomat-tool
import type { DataError } from "./DataError"
import type { DataProvider } from "./DataProvider"
import type { Locale } from "./Locale"
import type { Weekday } from "./Weekday"
import type { WeekendContainsDay } from "./WeekendContainsDay"
import type { pointer, codepoint } from "./diplomat-runtime.d.ts";


/** A Week calculator, useful to be passed in to `week_of_year()` on Date and DateTime types
*
*See the [Rust documentation for `WeekCalculator`](https://docs.rs/icu/latest/icu/calendar/week/struct.WeekCalculator.html) for more information.
*/


export class WeekCalculator {
    
    get ffiValue(): pointer;

    static createWithProvider(provider: DataProvider, locale: Locale): WeekCalculator;

    static fromFirstDayOfWeekAndMinWeekDays(firstWeekday: Weekday, minWeekDays: number): WeekCalculator;

    get firstWeekday(): Weekday;

    get minWeekDays(): number;

    get weekend(): WeekendContainsDay;

    constructor(locale: Locale);
}