// generated by diplomat-tool
import type { DataError } from "./DataError"
import type { DataProvider } from "./DataProvider"
import type { Locale } from "./Locale"
import type { WordBreakIteratorUtf16 } from "./WordBreakIteratorUtf16"
import type { pointer, codepoint } from "./diplomat-runtime.d.ts";


/** An ICU4X word-break segmenter, capable of finding word breakpoints in strings.
*
*See the [Rust documentation for `WordSegmenter`](https://docs.rs/icu/latest/icu/segmenter/struct.WordSegmenter.html) for more information.
*/


export class WordSegmenter {
    
    get ffiValue(): pointer;

    static createAuto(): WordSegmenter;

    static createAutoWithContentLocale(locale: Locale): WordSegmenter;

    static createAutoWithContentLocaleAndProvider(provider: DataProvider, locale: Locale): WordSegmenter;

    static createLstm(): WordSegmenter;

    static createLstmWithContentLocale(locale: Locale): WordSegmenter;

    static createLstmWithContentLocaleAndProvider(provider: DataProvider, locale: Locale): WordSegmenter;

    static createDictionary(): WordSegmenter;

    static createDictionaryWithContentLocale(locale: Locale): WordSegmenter;

    static createDictionaryWithContentLocaleAndProvider(provider: DataProvider, locale: Locale): WordSegmenter;

    segment(input: string): WordBreakIteratorUtf16;
}