# How to Contribute

We would love to accept your patches and contributions to this project.  Please
keep in mind a few areas that we don't want to change about the design:

*  Try not to add new dependencies unless they are already available in
   [ChromeOS](https://chromium.googlesource.com/chromiumos/third_party/rust_crates/).
*  Don't add new platform-specific integrations.  Integrating with the host
   system properly is the responsibility of the application, not this crate.

For anything larger than a small bug fix, it's a good idea to open an issue
first for discussion.

## Before you begin

### Sign our Contributor License Agreement

Contributions to this project must be accompanied by a
[Contributor License Agreement](https://cla.developers.google.com/about) (CLA).
You (or your employer) retain the copyright to your contribution; this simply
gives us permission to use and redistribute your contributions as part of the
project.

If you or your current employer have already signed the Google CLA (even if it
was for a different project), you probably don't need to do it again.

Visit <https://cla.developers.google.com/> to see your current agreements or to
sign a new one.

### Review our Community Guidelines

This project follows [Google's Open Source Community
Guidelines](https://opensource.google/conduct/).

## Contribution process

### Code Reviews

All submissions, including submissions by project members, require review. We
use [GitHub pull requests](https://docs.github.com/articles/about-pull-requests)
for this purpose.
