// This file is auto-generated by vulkano autogen from vk.xml header version 1.3.238.
// It should not be edited manually. Changes should be made by editing autogen.

#[doc = r" An enumeration of runtime errors that can be returned by Vulkan."]
#[derive(Clone, Copy, Debug, PartialEq, Eq, Hash)]
#[repr(i32)]
#[non_exhaustive]
pub enum VulkanError {
    OutOfHostMemory,
    OutOfDeviceMemory,
    InitializationFailed,
    DeviceLost,
    MemoryMapFailed,
    LayerNotPresent,
    ExtensionNotPresent,
    FeatureNotPresent,
    IncompatibleDriver,
    TooManyObjects,
    FormatNotSupported,
    FragmentedPool,
    Unknown,
    OutOfPoolMemory,
    InvalidExternalHandle,
    Fragmentation,
    InvalidOpaqueCaptureAddress,
    IncompatibleDisplay,
    NotPermitted,
    SurfaceLost,
    NativeWindowInUse,
    OutOfDate,
    ImageUsageNotSupported,
    VideoPictureLayoutNotSupported,
    VideoProfileOperationNotSupported,
    VideoProfileFormatNotSupported,
    VideoProfileCodecNotSupported,
    VideoStdVersionNotSupported,
    ValidationFailed,
    FullScreenExclusiveModeLost,
    CompressionExhausted,
    InvalidDrmFormatModifierPlaneLayout,
    InvalidShader,
    Unnamed(ash::vk::Result),
}
impl From<ash::vk::Result> for VulkanError {
    fn from(val: ash::vk::Result) -> VulkanError {
        match val {
            ash::vk::Result::ERROR_OUT_OF_HOST_MEMORY => Self::OutOfHostMemory,
            ash::vk::Result::ERROR_OUT_OF_DEVICE_MEMORY => Self::OutOfDeviceMemory,
            ash::vk::Result::ERROR_INITIALIZATION_FAILED => Self::InitializationFailed,
            ash::vk::Result::ERROR_DEVICE_LOST => Self::DeviceLost,
            ash::vk::Result::ERROR_MEMORY_MAP_FAILED => Self::MemoryMapFailed,
            ash::vk::Result::ERROR_LAYER_NOT_PRESENT => Self::LayerNotPresent,
            ash::vk::Result::ERROR_EXTENSION_NOT_PRESENT => Self::ExtensionNotPresent,
            ash::vk::Result::ERROR_FEATURE_NOT_PRESENT => Self::FeatureNotPresent,
            ash::vk::Result::ERROR_INCOMPATIBLE_DRIVER => Self::IncompatibleDriver,
            ash::vk::Result::ERROR_TOO_MANY_OBJECTS => Self::TooManyObjects,
            ash::vk::Result::ERROR_FORMAT_NOT_SUPPORTED => Self::FormatNotSupported,
            ash::vk::Result::ERROR_FRAGMENTED_POOL => Self::FragmentedPool,
            ash::vk::Result::ERROR_UNKNOWN => Self::Unknown,
            ash::vk::Result::ERROR_OUT_OF_POOL_MEMORY => Self::OutOfPoolMemory,
            ash::vk::Result::ERROR_INVALID_EXTERNAL_HANDLE => Self::InvalidExternalHandle,
            ash::vk::Result::ERROR_FRAGMENTATION => Self::Fragmentation,
            ash::vk::Result::ERROR_INVALID_OPAQUE_CAPTURE_ADDRESS => {
                Self::InvalidOpaqueCaptureAddress
            }
            ash::vk::Result::ERROR_INCOMPATIBLE_DISPLAY_KHR => Self::IncompatibleDisplay,
            ash::vk::Result::ERROR_NOT_PERMITTED_KHR => Self::NotPermitted,
            ash::vk::Result::ERROR_SURFACE_LOST_KHR => Self::SurfaceLost,
            ash::vk::Result::ERROR_NATIVE_WINDOW_IN_USE_KHR => Self::NativeWindowInUse,
            ash::vk::Result::ERROR_OUT_OF_DATE_KHR => Self::OutOfDate,
            ash::vk::Result::ERROR_IMAGE_USAGE_NOT_SUPPORTED_KHR => Self::ImageUsageNotSupported,
            ash::vk::Result::ERROR_VIDEO_PICTURE_LAYOUT_NOT_SUPPORTED_KHR => {
                Self::VideoPictureLayoutNotSupported
            }
            ash::vk::Result::ERROR_VIDEO_PROFILE_OPERATION_NOT_SUPPORTED_KHR => {
                Self::VideoProfileOperationNotSupported
            }
            ash::vk::Result::ERROR_VIDEO_PROFILE_FORMAT_NOT_SUPPORTED_KHR => {
                Self::VideoProfileFormatNotSupported
            }
            ash::vk::Result::ERROR_VIDEO_PROFILE_CODEC_NOT_SUPPORTED_KHR => {
                Self::VideoProfileCodecNotSupported
            }
            ash::vk::Result::ERROR_VIDEO_STD_VERSION_NOT_SUPPORTED_KHR => {
                Self::VideoStdVersionNotSupported
            }
            ash::vk::Result::ERROR_VALIDATION_FAILED_EXT => Self::ValidationFailed,
            ash::vk::Result::ERROR_FULL_SCREEN_EXCLUSIVE_MODE_LOST_EXT => {
                Self::FullScreenExclusiveModeLost
            }
            ash::vk::Result::ERROR_COMPRESSION_EXHAUSTED_EXT => Self::CompressionExhausted,
            ash::vk::Result::ERROR_INVALID_DRM_FORMAT_MODIFIER_PLANE_LAYOUT_EXT => {
                Self::InvalidDrmFormatModifierPlaneLayout
            }
            ash::vk::Result::ERROR_INVALID_SHADER_NV => Self::InvalidShader,
            x => Self::Unnamed(x),
        }
    }
}
